<?php
///////////////////////////////////////////////////////////////////////////

require_once 'lib/default_dune_plugin.php';
require_once 'lib/utils.php';
require_once 'lib/default_archive.php';


require_once 'lib/tv/tv_group_list_screen.php';
require_once 'lib/tv/tv_channel_list_screen.php';
require_once 'lib/tv/tv_favorites_screen.php';

require_once 'lib/vod/vod_list_screen.php';
require_once 'lib/vod/vod_search_screen.php';
require_once 'lib/vod/vod_genres_screen.php';
require_once 'lib/vod/vod_movie_screen.php';
require_once 'lib/vod/vod_series_list_screen.php';
require_once 'lib/vod/vod_favorites_screen.php';

require_once 'newrus_config.php';
require_once 'newrus_api.php';
require_once 'newrus.php';
require_once 'newrus_setup_screen.php';
require_once 'newrus_exception.php';
require_once 'newrus_tv.php';
require_once 'newrus_entry_handler.php';
require_once 'newrus_main_category_list_screen.php';
require_once 'newrus_tv_group_list_screen.php';
require_once 'newrus_channel_list_screen.php';

require_once 'newrus_vod_category_list_screen.php';
require_once 'newrus_vod.php';
require_once 'newrus_vod_list_screen.php';
require_once 'newrus_vod_genres_screen.php';

///////////////////////////////////////////////////////////////////////////

class Newrus_Plugin extends DefaultDunePlugin
{
    private $session;
    public function __construct()
    {
	$this->session = new Newrus_Api();
        $this->tv = new NewrusTv($this->session);
	$this->add_screen(new Newrus_MainCategoryListScreen($this->session,$this->tv));
        $this->vod = new Newrus_Vod($this->session);
        $tv_folder_views = $this->get_tv_folder_views();
	$this->entry_handler = new Newrus_EntryHandler($this->session,$this->tv);
        $this->add_screen(new NewrusTv_SetupScreen($this->session,$this->tv));

        $this->add_screen(new Newrus_TvGroupListScreen($this->tv,
                Newrus_Config::GET_TV_GROUP_LIST_FOLDER_VIEWS()));
        $this->add_screen(new NewrusTvChannelListScreen($this->tv,
                Newrus_Config::GET_TV_CHANNEL_LIST_FOLDER_VIEWS(),$this->session));
        $this->add_screen(new TvFavoritesScreen($this->tv,
                Newrus_Config::GET_TV_CHANNEL_LIST_FOLDER_VIEWS()));


        $this->add_screen(new Newrus_VodCategoryListScreen($this->session));
  
	$this->add_screen(new Newrus_VodListScreen($this->session,$this->vod));

        $this->add_screen(new VodMovieScreen($this->vod));

        $this->add_screen(new VodSeriesListScreen($this->vod));

        $this->add_screen(new VodFavoritesScreen($this->vod));

        $this->add_screen(new VodSearchScreen($this->vod));

        $this->add_screen(new Newrus_VodGenresScreen($this->vod));
	
    }

    ///////////////////////////////////////////////////////////////////////

    private function get_tv_folder_views()
    {
        return Newrus_Config::GET_TV_CHANNEL_LIST_FOLDER_VIEWS();
    }
}

///////////////////////////////////////////////////////////////////////////
?>
