<?php
///////////////////////////////////////////////////////////////////////////

require_once 'lib/hashed_array.php';
require_once 'lib/tv/abstract_tv.php';
require_once 'lib/tv/default_epg_item.php';


require_once 'newrus_channel.php';

///////////////////////////////////////////////////////////////////////////

class NewrusTv extends AbstractTv
{
    public $cookie = array();
    
    public function __construct($session)
    {
        parent::__construct(
            AbstractTv::MODE_CHANNELS_N_TO_M,
            Newrus_Config::TV_FAVORITES_SUPPORTED,
            true);
	$this->session = $session;
    }

    public function get_fav_icon_url()
    {
        return $this->session->get_icon('fav_tv.png');;
    }

    ///////////////////////////////////////////////////////////////////////
    public function newload(&$plugin_cookies)
	{
		hd_print('unload');
		if(is_null($this->channels) && is_null($this->groups))
			$this->load_channels($plugin_cookies);
	}
    ///////////////////////////////////////////////////////////////////////
    protected function load_channels(&$plugin_cookies)
    {
	$this->session->check_login($plugin_cookies);
        $this->channels = new HashedArray();
        $this->groups = new HashedArray();
	$group_tmp = null;
	$buffer = isset($plugin_cookies->buf_time) ? $plugin_cookies->buf_time : 0;
        if ($this->is_favorites_supported())
        {
            $this->groups->put(
                new FavoritesGroup(
                    $this,
                    '__favorites',
                    'Фавориты',
                    $this->session->get_icon('fav_tv.png')));
        }



        $this->groups->put( new AllChannelsGroup(
            		    $this,
            		    'Все каналы',
            		    $this->session->get_icon('all_tv.png')));
	#$this->session->login_newrus($plugin_cookies);
	$groups_tv = $this->session->get_channel_list();
        foreach ($groups_tv->groups as $group)
	{
		###$group_icon = $group->id.'_tv.png';
		$group_icon = 'http://icon.new-rus.tv/_logos/duneLogos/CACHE_NEWRUS/'.$group->id.'_tv.png';
		#hd_print("id: $eee");
		#hd_print("name: $group->name");
		$newrus_group = new DefaultGroup(
                	$group->id,
                	$group->name,
			##$this->session->get_icon($group_icon)
					$group_icon
                	);
                #$this->groups->put($newrus_group);
           	foreach ($group->channels as $channels)
		{
			#$icon = 'http://api.new-rus.tv/_logos/channelLogos/'.$channels->logo_big;
            $icon = 'http://icon.new-rus.tv/_logos/duneLogos/CACHE_NEWRUS/'.$channels->id.'.png';

			#$icon = $channels->id.'.png';
			
            #hd_print("id: $channels->id");
			#hd_print("name: $channels->name");
			#hd_print("icon: $icon");
			$newrus_channel = new Newrus_Channel(
				$channels->id,
				$channels->name,
				#$this->session->get_icon($icon),
                $icon,
				"",
				10,
				7,
				$buffer,//bufff
				intval($channels->protected), 
				$channels->have_archive,
				$channels->is_video);
			$this->channels->put($newrus_channel);

			$newrus_channel->add_group($newrus_group);
			$newrus_group->add_channel($newrus_channel);
		}
		$group_tmp [] = $newrus_group;
	}
	foreach ($group_tmp as $g)
	{	
		$size = $g->get_channels($plugin_cookies)->size();
		hd_print("group size:$size"); 
        	if ($size == 0)
        	{
             		hd_print("пустая группа");
        	}
        	else
        	{
			$this->groups->put($g);
        	}
 	}
    }

    ///////////////////////////////////////////////////////////////////////////
    public function get_tv_playback_url($channel_id, $archive_ts, $protect_code, &$plugin_cookies)
    {
        $this->ensure_channels_loaded($plugin_cookies);
	$this->session->check_login($plugin_cookies);
	$url = $this->session->get_url($channel_id,$archive_ts,$protect_code);
	return $url;	
        
 
    }
    ///////////////////////////////////////////////////////////////////////////

    public function get_day_epg_iterator($channel_id, $day_start_ts, &$plugin_cookies)
    {
	$this->ensure_channels_loaded($plugin_cookies);
	$day_str = gmstrftime('%d%m%y', $day_start_ts);
        $newrus_epg = $this->session->get_epg($channel_id,$day_str);
        $epg_items = array();
        foreach ($newrus_epg->epg as $epg)
        {
            $progname = $epg->progname;

            $arr = explode("\n", $epg->progname, 2);
            $name = count($arr) >= 1 ? trim($arr[0]) : '';
            $description = count($arr) == 2 ? $arr[1] : '';

            $start = intval($epg->ut_start);
            $end = -1;

            $epg_items[] = new DefaultEpgItem(
                $name, $description, $start, $end);
        }
	

        return new EpgIterator($epg_items, $day_start_ts, $day_start_ts + 86400);
    }
    public function get_archive(MediaURL $media_url)
    { 
        return $this->session->get_archive();
    }
}

///////////////////////////////////////////////////////////////////////////
?>
